'
' Copyright (c) 2001-2010 by PDFTron Systems Inc. All Rights Reserved.
'
Imports pdftron
Imports pdftron.Common
Imports pdftron.Filters
Imports pdftron.SDF
Imports pdftron.PDF

' This sample project illustrates how to recompress bi-tonal images in an 
' existing PDF document using JBIG2 compression. The sample is not intended 
' to be a generic PDF optimization tool.
' 
' You can download a sample scanned document using the following link:
'   http://www.pdftron.com/net/samplecode/data/US061222892.pdf
'
' Also a sample page compressed using CCITT Fax compression is located under 
' 'PDFNet/Samples/TestFiles' folder.

Public Class Form1
	Inherits System.Windows.Forms.Form

	Dim _JBIG2_hint As Obj = Nothing	 ' Initialized in New()

#Region " Windows Form Designer generated code "

	Public Sub New()
		MyBase.New()

		'This call is required by the Windows Form Designer.
		InitializeComponent()

		'Add any initialization after the InitializeComponent() call
		PDFNet.Initialize()

        Dim hint_set As ObjSet = New ObjSet
        _JBIG2_hint = hint_set.CreateArray()
        _JBIG2_hint.PushBackName("JBIG2")
        _JBIG2_hint.PushBackName("Lossless")
    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents lossy As System.Windows.Forms.CheckBox
    Friend WithEvents button3 As System.Windows.Forms.Button
    Friend WithEvents label1 As System.Windows.Forms.Label
    Friend WithEvents button2 As System.Windows.Forms.Button
    Friend WithEvents button1 As System.Windows.Forms.Button
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.lossy = New System.Windows.Forms.CheckBox
        Me.button3 = New System.Windows.Forms.Button
        Me.label1 = New System.Windows.Forms.Label
        Me.button2 = New System.Windows.Forms.Button
        Me.button1 = New System.Windows.Forms.Button
        Me.SuspendLayout()
        '
        'lossy
        '
        Me.lossy.Location = New System.Drawing.Point(24, 160)
        Me.lossy.Name = "lossy"
        Me.lossy.Size = New System.Drawing.Size(120, 32)
        Me.lossy.TabIndex = 9
        Me.lossy.Text = "Lossy Compression"
        '
        'button3
        '
        Me.button3.Location = New System.Drawing.Point(160, 216)
        Me.button3.Name = "button3"
        Me.button3.Size = New System.Drawing.Size(184, 40)
        Me.button3.TabIndex = 8
        Me.button3.Text = "Quit"
        '
        'label1
        '
        Me.label1.Location = New System.Drawing.Point(32, 16)
        Me.label1.Name = "label1"
        Me.label1.Size = New System.Drawing.Size(304, 64)
        Me.label1.TabIndex = 7
        Me.label1.Text = "This sample project illustrates how to recompress bi-tonal images in an existing " & _
        "PDF document using JBIG2 compression. The sample is not intended to be a generic" & _
        " PDF optimization tool."
        '
        'button2
        '
        Me.button2.Location = New System.Drawing.Point(160, 160)
        Me.button2.Name = "button2"
        Me.button2.Size = New System.Drawing.Size(184, 40)
        Me.button2.TabIndex = 6
        Me.button2.Text = "Save using JBIG2"
        '
        'button1
        '
        Me.button1.Location = New System.Drawing.Point(160, 104)
        Me.button1.Name = "button1"
        Me.button1.Size = New System.Drawing.Size(184, 40)
        Me.button1.TabIndex = 5
        Me.button1.Text = "Load PDF"
        '
        'Form1
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(6, 15)
        Me.ClientSize = New System.Drawing.Size(384, 280)
        Me.Controls.Add(Me.lossy)
        Me.Controls.Add(Me.button3)
        Me.Controls.Add(Me.label1)
        Me.Controls.Add(Me.button2)
        Me.Controls.Add(Me.button1)
        Me.Name = "Form1"
        Me.Text = "JBIG2Test"
        Me.ResumeLayout(False)

    End Sub

#End Region

	Private Sub button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles button3.Click
		Application.Exit()
	End Sub

	Private pdfdoc As pdfdoc = Nothing


	' On Load ... 
	Private Sub button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles button1.Click
		Dim dlg As OpenFileDialog = New OpenFileDialog
		dlg.Filter = "PDF (*.pdf)|*.pdf|All files (*.*)|*.*"

		If dlg.ShowDialog() = DialogResult.OK Then
			If Not pdfdoc Is Nothing Then
				pdfdoc.Close()
			End If

			pdfdoc = New PDFDoc(dlg.FileName)
			pdfdoc.InitSecurityHandler()
		End If
	End Sub

	' On Save...
	Private Sub button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles button2.Click
		Dim dlg As SaveFileDialog = New SaveFileDialog
		dlg.Filter = "PDF (*.pdf)|*.pdf|All files (*.*)|*.*"

		If dlg.ShowDialog() = DialogResult.OK Then
			If Not pdfdoc Is Nothing Then
				Recompress()
				pdfdoc.Save(dlg.FileName, SDFDoc.SaveOptions.e_remove_unused)
				pdfdoc.Close()
				pdfdoc = Nothing
			End If
		End If
	End Sub

	Dim _img_buf As Byte() = Nothing

	Public Sub Recompress()

		If (lossy.Checked) Then
			_JBIG2_hint.GetAt(1).SetName("Lossy")
		Else
			_JBIG2_hint.GetAt(1).SetName("Lossless")
		End If

		Dim cos_doc As SDFDoc = pdfdoc.GetSDFDoc()
		Dim num_objs As Integer = cos_doc.XRefSize()

		For i As Integer = 1 To num_objs - 1
			Dim obj As Obj = cos_doc.GetObj(i)
			If Not (obj Is Nothing Or obj.IsFree()) Then
				' Process only images
				If obj.IsStream() Then
					Dim itr As DictIterator = obj.Find("Subtype")
                    If itr.HasNext() Then
                        If itr.Value().GetName() = "Image" Then
                            Dim input_image As PDFTRON.PDF.Image = New PDFTRON.PDF.Image(obj)
                            Dim new_image As PDFTRON.PDF.Image = Nothing

                            ' Process only gray-scale images
                            If input_image.GetComponentNum() = 1 Then
                                Dim bpc As Integer = input_image.GetBitsPerComponent()
                                If bpc = 1 Then
                                    Dim reader As FilterReader = New FilterReader(obj.GetDecodedStream())
                                    new_image = PDFTRON.PDF.Image.Create(cos_doc, reader, input_image.GetImageWidth(), input_image.GetImageHeight(), 1, ColorSpace.CreateDeviceGray(), _JBIG2_hint)
                                ElseIf bpc = 8 Then
                                    ' Some black and white images are stored as 8 bits per pixel
                                    ' grayscale images. In this case convert the image to 1 BPC 
                                    ' image and then compress using JBIG2.
                                    Dim width As Integer = input_image.GetImageWidth()
                                    Dim height As Integer = input_image.GetImageHeight()
                                    Dim bytes_per_row As Integer = (width + 7) / 8
                                    Dim img_buf_size As Integer = width * height

                                    If _img_buf Is Nothing Or _img_buf.Length < img_buf_size Then
                                        _img_buf = New Byte(img_buf_size * 2) {}
                                    End If

                                    Dim reader As New FilterReader(obj.GetDecodedStream())
                                    Dim acc As Byte
                                    Dim in_pos As Integer = 0
                                    Dim out_pos As Integer = 0
                                    Dim pad As Integer = width Mod 8

                                    reader.Read(_img_buf)

                                    Dim y As Integer

                                    While y < height
                                        acc = 0
                                        Dim x As Integer

                                        While x < width
                                            acc = acc << 1


                                            If _img_buf(in_pos + 1) > 128 Then
                                                acc = acc Or &H1
                                            End If

                                            If x <> 0 And x Mod 8 = 0 Then
                                                _img_buf(out_pos) = acc
                                            End If
                                        End While

                                        If pad <> 0 Then
                                            acc = acc << (8 - pad)
                                        End If

                                        _img_buf(out_pos) = acc
                                    End While

                                    new_image = PDFTRON.PDF.Image.Create(cos_doc, _img_buf, width, height, 1, ColorSpace.CreateDeviceGray(), _JBIG2_hint)
                                End If

                                If Not new_image Is Nothing Then
                                    Dim new_img_obj As Obj = new_image.GetSDFObj()

                                    ' Copy any important entries from the image dictionary
                                    itr = obj.Find("Decode")
                                    If itr.HasNext() Then
                                        new_img_obj.Put("Decode", itr.Value())
                                    End If
                                    itr = obj.Find("ImageMask")
                                    If itr.HasNext() Then
                                        new_img_obj.Put("ImageMask", itr.Value())
                                    End If
                                    itr = obj.Find("Mask")
                                    If itr.HasNext() Then
                                        new_img_obj.Put("Mask", itr.Value())
                                    End If
                                    cos_doc.Swap(i, new_image.GetSDFObj().GetObjNum())
                                End If
                            End If
                    End If
                End If
            End If
            End If
        Next
	End Sub
End Class
